<?php
/*
Plugin Name: DBWD Bookmark Page
Plugin URI: http://sites.tghosting.net/?page_id=545
Description: Places a Bookmark Button on Your Page - Selectable Graphics and Positioning - Firefox and IE tested.
Author: Debra Berube
Version: 3.3
Author URI: http://sites.tghosting.net/?page_id=521
*/

$DBWD_bookmark_page = new DBWD_Bookmark_Page();
$DBWD_bookmark_page->add_DBWD_menu();

class DBWD_Bookmark_Page
	{
	function add_DBWD_menu()
		{
		add_action('admin_menu', array('DBWD_bookmark_page', 'admin_add_menu'));
		add_action('wp_head', array('DBWD_bookmark_page', 'DBWD_add_header_data'));
		add_action('wp_footer', array('DBWD_bookmark_page', 'DBWD_add_button'));
		}

	public static function admin_add_menu()
		{
		add_options_page('DBWD Bookmark Page', 'DBWD Bookmark', 8, 'DBWD_bookmark_page', array('DBWD_bookmark_page', 'options'));
		}
	
	function data_save()
		{
		if(isset($_POST['submitter']))
			{
			$option_name = 'DBWD_bookmark_page';
			$options['data'][0] = $_POST['Bookmark_group_1'];
			$options['data'][1] = $_POST['Bookmark_offset_position_1'];
			$options['data'][2] = $_POST['Bookmark_offset_down_1'];
			$options['data'][3] = $_POST['Bookmark_offset_across_1'];
			$options['data'][4] = $_POST['Bookmark_on_off_1'];
			$options['data'][5] = $_POST['imageURL'];
			$options['data'][6] = $_POST['DBWD_sliderValue'];

			if ($_POST['fixedButton'] == "checked") { $checkedState = "checked"; } else { $checkedState = ""; }
			$options['data'][7] = $checkedState;								
			
			if ( get_option($option_name) )
				update_option($option_name, $options);
			else
				add_option( $option_name, $options );
			}
		}
	
	public static function DBWD_add_header_data()
		{
		$zIndexMultiple = "10000";
			
		$domain_url = trailingslashit(get_bloginfo('url'));
		$domain_name = get_bloginfo('name');
		$blog_url = trailingslashit(get_bloginfo('wpurl'));
		$theme_url = trailingslashit(get_bloginfo('template_url'));
		$plugin_url = trailingslashit(WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)));
		
		$options = get_option('DBWD_bookmark_page');
		$output = $options['data'][0];
		
		$output = str_replace('%domain_url%', $domain_url, $output);
		$output = str_replace('%blog_url%', $blog_url, $output);
		$output = str_replace('%theme_url%', $theme_url, $output);
		$output = str_replace('%plugin_url%', $plugin_url, $output);
		
		$zIndexOutput = $options['data'][6] * $zIndexMultiple;
		
		$addOffsetBMValue = $options['data'][2];
		if (is_admin_bar_showing() == 1)
			{
			$addOffsetBMValue += 26; 
			}
	
		$output = "<script type=\"text/javascript\"> 
		function bookmark(title, url)
			{
		   if(document.all)
		   	{ // ie
		      window.external.AddFavorite(url, title);
		    	}
		    else if(window.sidebar) 
		    	{ // firefox
		      window.sidebar.addPanel(title, url, \"\");
		    	}
		    else if(window.opera && window.print) 
		    	{ // opera
		      var elem = document.createElement('a');
		      elem.setAttribute('href',url);
		      elem.setAttribute('title',title);
		      elem.setAttribute('rel','sidebar');
		      elem.click(); // this.title=document.title;
		    	}
			}
		</script>";
		
		$output = "\n<!-- DBWD Bookmark - Begin Code -->\n" . $output . "\n<!-- DBWD Bookmark - End Code -->\n";
		
		if ($options['data'][4] == "on") { echo stripslashes($output); } 
		}

	public static function DBWD_add_button()
		{
		$zIndexMultiple = "10000";
			
		$domain_url = trailingslashit(get_bloginfo('url'));
		$domain_name = get_bloginfo('name');
		$blog_url = trailingslashit(get_bloginfo('wpurl'));
		$theme_url = trailingslashit(get_bloginfo('template_url'));
		$plugin_url = trailingslashit(WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)));
		
		$options = get_option('DBWD_bookmark_page');
		$output = $options['data'][0];
		
		$output = str_replace('%domain_url%', $domain_url, $output);
		$output = str_replace('%blog_url%', $blog_url, $output);
		$output = str_replace('%theme_url%', $theme_url, $output);
		$output = str_replace('%plugin_url%', $plugin_url, $output);
		
		$zIndexOutput = $options['data'][6] * $zIndexMultiple;
		
		$addOffsetBMValue = $options['data'][2];
		if (is_admin_bar_showing() == 1)
			{
			$addOffsetBMValue += 26; 
			}
	
		if ($options['data'][7] == "checked") { $fixedPositionFlag = "fixed"; } else { $fixedPositionFlag = "absolute"; }
	
		$output = "<a id=\"bookmarkPage\" style=\"position: " . $fixedPositionFlag . "; top: " . $addOffsetBMValue . "px; " . $options['data'][1] . 
		": " . $options['data'][3] . "px; z-index: " . $zIndexOutput . ";\" href=\"javascript:bookmark('" . $domain_name . "','" . $domain_url . "'); \">
		<img src=\"";
		
		if('userImage_1' == $options['data'][0])
			{
			$workStringURL = $options['data'][5];
			
			$workResult = "0";
			
			$workTestString = substr($options['data'][5],-4);
			if (($workTestString == ".gif") || ($workTestString == ".jpg") || ($workTestString == ".png"))
				{
				$workResult = 1;
				}
				
			if((!filter_var($workStringURL, FILTER_VALIDATE_URL, FILTER_FLAG_HOST_REQUIRED)) || ($workResult != 1))
				{ $output = $output . $plugin_url . "buttons/Bookmark_1.gif\""; }
			else
				{	
				$output = $output . $options['data'][5] . "\"";
				}
			}
		else 
			{ $output = $output . $plugin_url . "buttons/" . $options['data'][0] . ".gif\""; }

		$output = $output . " border=\"0\" alt=\"Bookmark this page\" /></a>";
		
		$output = "\n<!-- DBWD Bookmark - Begin Code -->\n" . $output . "\n<!-- DBWD Bookmark - End Code -->\n";
		
		if ($options['data'][4] == "on") { echo stripslashes($output); } 
		}

	public static function options()
		{
		DBWD_bookmark_page::data_save();

		$zIndexMultiple = "10000";

		$plugin_data = get_plugin_data( __FILE__ );
		$plugin_version = $plugin_data['Version'];

		$options = get_option('DBWD_bookmark_page');
		
		$domain_url = trailingslashit(get_bloginfo('url'));
		$blog_url = trailingslashit(get_bloginfo('wpurl'));
		$theme_url = trailingslashit(get_bloginfo('template_url'));
		$plugin_url = trailingslashit(WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)));
		
?>

		<div class="wrap">
			<div id="icon-options-general" class="icon32"></div>
			<div><br><font size=5 color=navy><b>DBWD Bookmark This Page</b></font><div>

			<div id="CAS" style="position:absolute; width:408px; top: 18px; left: 441px; background-color: #ffffff; background-image: url(<?php print $plugin_url ?>gifs/topMenuBG.gif); border: 1px solid gray; -moz-border-radius: 15px; border-radius: 15px;">
				<div id="CASinner" style="margin:3px; vertical-align:top; " align=left>
					&nbsp;&nbsp;&nbsp;&nbsp;*&nbsp;
					<a href="mailto:support@tghosting.net?subject=Bookmark Bug - Please give details of the issue and your URL">Report a Bug</a>
					&nbsp;&nbsp;&nbsp;&nbsp;*&nbsp;
					<a href="mailto:support@tghosting.net?subject=Bookmark Question">Ask a Question</a>
					&nbsp;&nbsp;&nbsp;&nbsp;*&nbsp;
					<a href="mailto:support@tghosting.net?subject=Bookmark Comments">We Welcome Your Comments</a>
				</div>
			</div>

			<div id="Credits" style="position:relative; width:850px; top:8px; background-color: #f8f8ff; 
				background-image: url(<?php print $plugin_url ?>gifs/topMenuBG.gif); border: 1px solid gray; -moz-border-radius: 15px; border-radius: 15px;">
				<div  style="margin: 4px; text-align:center;">
					<font size=2 color=black>
					*&nbsp;
					<a href="http://sites.tghosting.net/?page_id=594" target="_blank">Plugin Homepage</a>&nbsp;&nbsp;
<!--					*&nbsp;
					<a href="http://sites.tghosting.net/?page_id=769" target="_blank">All Plugins Available</a>&nbsp;&nbsp; -->
					*&nbsp;
					<a href="http://sites.tghosting.net" target="_blank">D.B. Web Development</a>&nbsp;&nbsp;
					*&nbsp;  
					<a href="http://sites.tghosting.net/?page_id=521" target="_blank">Plugin Author: Debra Berube</a>&nbsp;&nbsp;
					*&nbsp;
					<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=42TK76NCPLAQJ" target="_blank">Please Contribute</a></font>	
				</div>
			</div>
			
			<br>
			
			<?php if('' == $options['data'][0]) 
				{
				echo("<br><font size=4 color=red><b>Plugins First Use</b>: You Must Click \"Save Changes\" Below to Activate a Button.</font><br>"); 
				} ?>
			<br>
			<font size=3>Places a Bookmark Button in the Header Area to Encourage Your Visitors to Actually Bookmark the Page</font><br>
			<br>

			<form method="post" name="DBWD_bookmark_page">
				<h3>Select a Button Style to Use to Best Match Your Header Area</h3>
				<table border=0 cellpadding=0 cellspacing=10>
					<tr>
					<td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_1"<?php checked(( 'Bookmark_1' == $options['data'][0] ) || ('' == $options['data'][0])); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_1.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_1a"<?php checked( 'Bookmark_1a' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_1a.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_1b"<?php checked( 'Bookmark_1b' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_1b.gif" /></td>
					<td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_1c"<?php checked( 'Bookmark_1c' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_1c.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_1d"<?php checked( 'Bookmark_1d' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_1d.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_1e"<?php checked( 'Bookmark_1e' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_1e.gif" /></td>
					</tr>

					<tr><td height=12></td></tr>
					<tr>
					<td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_2"<?php checked( 'Bookmark_2' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_2.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_2a"<?php checked( 'Bookmark_2a' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_2a.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_2b"<?php checked( 'Bookmark_2b' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_2b.gif" /></td>
					<td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_2c"<?php checked( 'Bookmark_2c' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_2c.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_2d"<?php checked( 'Bookmark_2d' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_2d.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_2e"<?php checked( 'Bookmark_2e' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_2e.gif" /></td>
					</tr>

					<tr><td height=0></td></tr>
					<tr>
					<td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_3"<?php checked( 'Bookmark_3' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_3.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_3a"<?php checked( 'Bookmark_3a' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_3a.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_3b"<?php checked( 'Bookmark_3b' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_3b.gif" /></td>
					<td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_3c"<?php checked( 'Bookmark_3c' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_3c.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_3d"<?php checked( 'Bookmark_3d' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_3d.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_3e"<?php checked( 'Bookmark_3e' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_3e.gif" /></td>
					</tr>

					<tr><td height=8></td></tr>
					<tr>
					<td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_4"<?php checked( 'Bookmark_4' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_4.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_4a"<?php checked( 'Bookmark_4a' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_4a.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_4b"<?php checked( 'Bookmark_4b' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_4b.gif" /></td>
					<td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_4c"<?php checked( 'Bookmark_4c' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_4c.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_4d"<?php checked( 'Bookmark_4d' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_4d.gif" />
					</td><td align=left>
						<input type="radio" name="Bookmark_group_1" value="Bookmark_4e"<?php checked( 'Bookmark_4e' == $options['data'][0] ); ?>>
						&nbsp;<img src="<?php print $plugin_url ?>buttons/Bookmark_4e.gif" /></td>
					</tr>
				</table>
				<br>
				<h3>If You Prefer You May Instead Point to an Image on Your Server or Elsewhere</h3>
					&nbsp;&nbsp;
					<input type="radio" name="Bookmark_group_1" value="userImage_1"<?php checked( 'userImage_1' == $options['data'][0] ); ?>>
					&nbsp;URL to your own Bookmark Image: <input type="text" name="imageURL" size=100 maxlength=128 value="<?php 
							if ($options['data'][5] == '') echo("http://");	else echo($options['data'][5]); ?>">
					<br>
					&nbsp;&nbsp;&nbsp;&nbsp;
					<font size=1 color=gray>(Note: "http://" must be present in URL - jpg, gif or png only - A bad Image URL will display the default button or no button at all)</font>
				
				<br><br>
				<h3>Select a Top Corner and XY offsets to position your button in the Header Area</h3>

				&nbsp;&nbsp;
				<input type="radio" name="Bookmark_offset_position_1" value="left"<?php checked(( 'left' == $options['data'][1] ) ||('' == $options['data'][1])); ?>>
				&nbsp;Top Left
				&nbsp;&nbsp;&nbsp;
				<input type="radio" name="Bookmark_offset_position_1" value="right"<?php checked( 'right' == $options['data'][1] ); ?>>
				&nbsp;Top Right

				<br><br>
				&nbsp;&nbsp;
				<input type="number" name="Bookmark_offset_down_1" value="<?php if('' == $options['data'][2]) { echo ("0"); } else { echo($options['data'][2]); } ?>">
				&nbsp;Down from Top Offset in Pixels (Top of Button - Y Coordinate)
				<br><br>
				&nbsp;&nbsp;
				<input type="number" name="Bookmark_offset_across_1" value="<?php if('' == $options['data'][3]) { echo ("0"); } else { echo($options['data'][3]); }  ?>">
				&nbsp;Across Offset from Selected Side in Pixels (Closest Side of Button - X Coordinate)
				<br><br>
				&nbsp;&nbsp;
				<input type="checkbox" name="fixedButton" value="checked" <?php print $options['data'][7] ?>>
				&nbsp; Set To Fixed Position - If checked the button will not move when the screen scrolls
				
				<br><br><br>
				<input type="submit" name="submitter" value="<?php esc_attr_e('Save Changes') ?>" class="button-primary" />
				<br><br><br>
				<hr align="left" width=50%>
				<br>
      		<script type="text/javascript" src="<?php print $plugin_url ?>js/dhtmlxSlider/codebase/dhtmlxcommon.js"></script>
      		<script type="text/javascript" src="<?php print $plugin_url ?>js/dhtmlxSlider/codebase/dhtmlxslider.js"></script>
      		<script type="text/javascript" src="<?php print $plugin_url ?>js/dhtmlxSlider/codebase/ext/dhtmlxslider_start.js"></script>
     			<link rel="stylesheet" type="text/css" href="<?php print $plugin_url ?>js/dhtmlxSlider/codebase/dhtmlxslider.css">

				<h3>z-Index Setting - Moves the Button Forward or Backwards through the screens layers.</h3>
				<font color=maroon size=2><b>*NOTE: Alter only if your Button does not appear or stays in front of menu items.
					<br>There is no need to change this if the Bookmark Button functions correctly.</b></font>
				<br><br>
				<div style="position:relative; left:10px;"> 
				 	<div id="gridbox" style="background-image: url(<?php print $plugin_url ?>gifs/sliderBackground.gif); width:460px; height:40px; position:absolute; top:0px; left:0px; border: 1px solid navy; -moz-border-radius: 8px; border-radius: 8px;">
				 		<div id="sliderText" style="width:60px; position:absolute; top:10px; left:10px;">
				 			<font size=2 color=navy>z-Index</font></div> 
						<input type="number" id="sliderInput" name="DBWD_sliderValue" style="width:31px; position:absolute; top:7px; left:62px; font-size:12px; border: 1px solid navy;">
				 		<div id="sliderText2" style="width:10px; position:absolute; top:11px; left:104px;">
				 			<font size=2 color=navy>%</font></div> 
						<div id="DBWD_BM_slider" style="position:absolute;top:13px;left:130px;">
					   		<script>
				     				var DBWD_slider = new dhtmlxSlider("DBWD_BM_slider", 
				     					{
				      		   	size:300,           
				      		   	skin: "dhx_skyblue",
				      		   	vertical:false,
				      		   	step:1,
				      		   	min:0,
				      		   	max:200,
				      		   	value:<?php if('' == $options['data'][6]) { echo ("100"); } else { echo($options['data'][6]); } ?>           
				      		   	});
				      		
				      			DBWD_slider.linkTo("sliderInput");
									DBWD_slider.setImagePath("<?php print $plugin_url ?>js/dhtmlxSlider/codebase/imgs/");
									DBWD_slider.init();
								</script>
						</div>
					</div>
					<div style="width:480px; position:absolute; top:50px; left:0px;">
						<font size=1 color=black>The z-Index helps to position the button in front of, or behind, other images that may be in the Header.
						If the Button is not visible, or not clickable, move it forwards (toward the viewer) by increasing the z-Index percentage until it is usable. 
						If the button appears in front of items in the Header (IE. Menus...) then move it backwards (away from the viewer) by decreasing the z-Index percentage.
						Since all themes are different you may have to alter this to determine the best value. Your final z-Index value will be the selected percentage 
						number times <?php print $zIndexMultiple ?>. Save Changes to test or apply.
					</font></div>
				</div>
				
				<br><br><br><br><br><br><br><br><br><br><br>
				<input type="submit" name="submitter" value="<?php esc_attr_e('Save Changes') ?>" class="button-primary" />
				<br><br><br>
				<hr align="left" width=50%>
				<br>
				<table height=30><tr><td height=15>
				&nbsp;&nbsp;
				<input type="radio" name="Bookmark_on_off_1" value="on"<?php checked(( 'on' == $options['data'][4] ) ||('' == $options['data'][4])); ?>>
				&nbsp;Enable Bookmark Button Display</td>
				<td height=30 rowspan=2 valign=middle><img src="<?php print $plugin_url ?>gifs/guide.gif" /></td>
				<td height=30 rowspan=2 valign=middle>Use to Temporarily Disable the Bookmark Button if Required</td>
				<tr><td height=15>
				&nbsp;&nbsp;
				<input type="radio" name="Bookmark_on_off_1" value="off"<?php checked( 'off' == $options['data'][4] ); ?>>
				&nbsp;Disable Bookmark Button Display</td>
				</tr></table>

				<br>
				<input type="submit" name="submitter" value="<?php esc_attr_e('Save Changes') ?>" class="button-primary" />
				








			</form>

			<br><br><br>
			<font size=1 color=black>D.B. Web Development - Bookmark Button - Version: <?php echo($plugin_version); ?>.</font>
		</div>
		<?php
		}
	}
?>